% ausgleichpoly.m
% Kap. 7.6
% Ausgleichspolynome durch die Methode der kleinsten Quadrate


% Ausgleichspolynom 3. Ordnung durch verrauschte Medaten legen
% u: Eingangvektor
% y: Mevektor
% Polynomordnung 3

format compact

%u = (-3:0.1:3)';                   % Eingangswerte zwischen -3 und 3
%y = 1 + 2.*u - 0.1.*u.^2 + u.^3;   % exakte Mewerte
%y = y + 0.2.*(rand(size(y))-0.5);  % Mewerte verrauschen
%save datensatz.mat u y

% Datensatz laden
load datensatz.mat
% Matrizen und Vektoren des linearen Gleichungssystems bilden
d = y; 
C = [ones(length(u),1), u, u.^2, u.^3];

% Gleichungssystem gem least squares lsen
x = C \ d

pause

% Lsung mittels polyfit
load datensatz.mat
x = polyfit(u, y, 3)

pause

% Nonnegative Least Squares

d = y; 
C = [ones(length(u),1), u, u.^2, u.^3];
options=optimset(@lsqnonneg);
options=optimset(options,'Display','final');

[x,resnorm] = lsqnonneg(C,d,options)

% Vergleich der Norm ohne NB und mit lsqnonneg

norm(C*lsqnonneg(C,d,x0,options)-d)
norm(C*(C\d)-d)

pause

% Lineare Least Squares mit Gleichungs-NB: lsqlin

d = y; 
C = [ones(length(u),1), u, u.^2, u.^3];
x0 = [4 -1 1 1]; 
options=optimset(@lsqlin);
options=optimset(options,'Display','final','LargeScale','off');
Aeq = [1 1 0 0]; 
beq = [3];
[x,resnorm] = lsqlin(C,d,[],[],Aeq,beq,[],[],x0,options)
