% curvefit_bsp.m
% Kap. 7.6
% Nichtlineare Ausgleichsfunktionen durch die Methode der kleinsten Quadrate


% Curvefit mit einer nichtlinearen Funktion f_fit (inline object)
% aus knstlich erzeugten Medaten

format compact
clear all

% Daten erzeugen
% T = 2;
% omega = 2*pi;
% K = 2.5;
% t = 0:0.05:10;                         % Zeitwerte von bis 10s
% y = K.*(exp(-t./T).*sin(omega.*t));    % abklingende Schwingung
% y = y + 0.2.*(rand(size(y))-0.5);      % Daten verrauschen
% save datensatz_curve.mat t y

% Datensatz laden
load datensatz_curve.mat

% Messdaten grafisch darstellen
subplot(221)
plot(t,y)
axis([0 10 -2 2.5])
grid on 
xlabel('Zeit [s]')
ylabel('y(t)')
% print -deps pt2.eps

pause 


% Funktion zur Interpolation definieren
% x(1) = K, x(2) = T, x(3) = omega

f_fit = inline('x(1).*(exp(-xdata./x(2)).*sin(x(3).*xdata))','x','xdata');

pause

% Anfangswerte fr x(1), x(2) und x(3) setzen und Optionen whlen
x0 = [1 1 4]; 
options = optimset(@lsqcurvefit);
options = optimset(options,'Algorithm','levenberg-marquardt','Display','final');

pause

% Optimierung starten

[x,resnorm] = lsqcurvefit(f_fit,x0,t,y,[],[],options)
