% curvefit_dat.m
% Datensatz zu Aufgabe 7.8.6, optimization TB erzeugen
format compact; clear all

T = 2.5;                       % Abklingzeitkonstante
omega1 = 2*pi; omega2 = 3*pi;   % beide Frequenzen
phi1 = 2; phi2 = 3.5;           % beide Phasen

t = (0:0.1:10)';                   % Zeitraum 0..10 Sekunden
% Funktionswert berechnen
y = exp(-t./T).*(sin(omega1.*t-phi1)+sin(omega2.*t-phi2));
% Daten verrauschen
y = y + 0.2.*y.*(rand(size(y))-0.5);  

% Datensatz speichern
save curve_daten.mat t y              % mat Datei speichern

datei = fopen ('curve_daten.txt', 'w');    % ASCII Datei speichern
fprintf (datei, '%7.4f  %7.4f\n', [t y]');
fclose (datei);
